% script di prova dei metodi iterativi

% definisco il sistema lineare Ax=b
% con A triadiagonale
n = 10; % dimensione della matrice
A = 3*diag(ones(n,1))-1*diag(ones(n-1,1),-1)-1*diag(ones(n-1,1),1);
% costruisco b in modo che x sia la soluzione esatta
x = ones(n,1);
b = A*x;

% specifico i parametri di convergenza del metodo iterativo
x0   = zeros(n,1); % punto di partenza
toll = 1E-6; % tolleranza per il residuo
kmax = 1000; % numero massimo di iterazioni

%  chiamo il metodo di Jacobi e Gauss-Seidel
[xkJAC,resxkJAC] = jac(A,b,x0,toll,kmax);
[xkGSS,resxkGSS] = gss(A,b,x0,toll,kmax);

%  grafico errore
semilogy(0:length(resxkJAC)-1,resxkJAC,'-ob','lineWidth',2)
hold on
semilogy(0:length(resxkGSS)-1,resxkGSS,'-om','lineWidth',2)
hold off
legend('Jacobi','Gauss-Seidel')
xlabel('k','fontSize',18)
ylabel('norma residuo','fontSize',18)







